<?
class Document {
    function Document() {
        $this->rawTextIsRead = false;
        $this->origTextIsRead = false;
        $this->rawText = "";
        $this->origText = "";
        
        $this->doc_id   = 0;
    }

    function fillFromDB($db, $doc_id) {
        $q = "SELECT *,
               UNIX_TIMESTAMP(preface_last_update) as unix_preface_last_update,
               UNIX_TIMESTAMP(when_orig_created) as unix_when_orig_created
              FROM docs
              WHERE doc_id = $doc_id";
        $res = $db->query($q);
        if ($res->numRows() > 1) {
            echo "bad bad bad";
            vardump($db->getAll($q));
        }

        $docRow = $db->getRow($q);

        $this->fillFromRow($docRow);
    }

    function fillFromRow($docRow) {
        foreach($docRow as $k => $v) {
            $this->$k = $v;
        }
    }
    
    function fillFromInput($name, $mareaowner_id, $parent_doc_id, $rawText,
                           $preface_text, $orig_author) {
        $this->name = $name;
        $this->mareaowner_id = $mareaowner_id;
        $this->parent_doc_id = $parent_doc_id;
        $this->rawText = $rawText;
        $this->preface_text = $preface_text;
        $this->orig_author = $orig_author;
    }

    function getRawText() {
        if (! $this->rawTextIsRead) {
            $this->readRawText();
        }
        return $this->rawText;
    }

    function getOrigText() {
        if (! $this->origTextIsRead) {
            $this->readOrigText();
        }
        return $this->origText;
    }

    function getFullFilename() {
        $ffn  = POD_FILE_ROOT."/files";
        $ffn .= "/". $this->mareaowner_id ."/". $this->doc_id;
        $ffn .= "/". $this->docNameAsFilename();
        $ffn .= ".docrefd.txt";
        return $ffn;
    }
    function getOrigFullFilename() {
        $ffn  = POD_FILE_ROOT."/files";
        $ffn .= "/". $this->mareaowner_id ."/". $this->doc_id;
        $ffn .= "/". $this->docNameAsFilename();
        $ffn .= ".orig.txt";
        return $ffn;
    }
    function getFullUrl() {
        $url = POD_URL_ROOT ."/files/";
        $url .= $this->mareaowner_id ."/". $this->doc_id;
        $url .= "/".urlencode($this->docNameAsFilename()).".docrefd.txt";
        return $url;
    }
    function getOrigFullUrl() {
        $url = POD_URL_ROOT ."/files/";
        $url .= $this->mareaowner_id ."/". $this->doc_id;
        $url .= "/".urlencode($this->docNameAsFilename()).".orig.txt";
        return $url;
    }

    function docNameAsFilename() {
        $n = $this->name;
        $n = preg_replace('/ /', '_', $n);
        $n = preg_replace('/\//', '_', $n);
        return $n;
    }

    function readRawText() {
        $fn = $this->getFullFilename();
        if(!file_exists($fn)) {
            die("Document.readText(): Oops, '$fn' doesnt exist");
        }

        $fp = fopen($fn, "r");
        $this->rawText = fread($fp, filesize($fn)); //One fell swoop
        $this->rawTextIsRead = true;
        fclose($fp);
    }

    function readOrigText() {
        $fn = $this->getOrigFullFilename();
        if(!file_exists($fn)) {
            die("Document.readText(): Oops, '$fn' doesnt exist");
        }

        $fp = fopen($fn, "r");
        $this->origText = fread($fp, filesize($fn)); //One fell swoop
        $this->origTextIsRead = true;
        fclose($fp);
    }


    function insertNewDocref($docref_loc, $docref_id)  {
        if(!$this->rawTextIsRead) {
            $this->readRawText();
        }

        $toks = preg_split('/ /', $this->rawText);
        array_insert($toks, "[[$docref_id]]", $docref_loc+1);
        $this->rawText = implode(" ", $toks);
    }

    /* XXX race condition, need flock? No-- there's never simult editing! */
    function storeText() {
        $fp = fopen($this->getFullFilename(), 'w');
        fwrite($fp, $this->rawText);
        fclose($fp);
    }

    /* no race condition b/c this happens only once...? */
    function storeTextAsOrig() {
        $fname = $this->getOrigFullfilename();
        $fp = fopen($fname, 'w');
        fwrite($fp, $this->rawText);
        fclose($fp);
    }

    /* XXX race conditions with the num_siblings business */
    function storeAsNew($db) {
        $q= "SELECT tag FROM docs
             WHERE doc_id = $this->parent_doc_id AND
                   mareaowner_id = $this->mareaowner_id";
        $parent_tag = $db->getOne($q); //Empty string if no parent cdoc
        
        

        $q = "SELECT doc_id FROM docs
              WHERE parent_doc_id = $this->parent_doc_id AND
                    mareaowner_id = $this->mareaowner_id";
        $res = $db->query($q);
        $num_siblings = $res->numRows();
        echo "numsibs: '$num_siblings'";

        $mytag = $parent_tag .($num_siblings+1) .".";

        $q = "INSERT docs VALUES
         (null,
          $this->mareaowner_id,
        '".addslashes($this->name)."',
          $this->parent_doc_id,
        '".addslashes($this->preface_text)."',
          NOW(),"               //preface_last_update
            ."'".addslashes($this->orig_author)."'," //preface_last_update_by_username
            ."'".addslashes($this->orig_author)."'," //orig_author
            ."NOW(),"               //when_orig_created
            ."0,"                   //orig_preface_docref_id
            ."0,"                   //orig_preface_msg_id
            ."'$mytag')";            //tag (duh)
//        echo "<PRE>newdoc insertion query [from Document.php]: $q </pre>";
        $db->query($q);
        
        
        $this->doc_id = $db->getOne("SELECT LAST_INSERT_ID()");
        system("mkdir -p -m 2775 " . dirname($this->getFullFilename()) . " 2>&1");
        $this->storeText();
        $this->storeTextAsOrig();
    }

    function storeFinalize($db, $orig_preface_docref_id, $orig_preface_msg_id) {
        $q = "UPDATE docs SET orig_preface_docref_id = $orig_preface_docref_id,
                                 orig_preface_msg_id = $orig_preface_msg_id
              WHERE doc_id = $this->doc_id";
        $db->query($q);
    }

    /* Note: this function, dhtml-wise, is heavily interdependent
     * with workspace.php */
    function renderForWorkspace($db)  {
        if(!$this->rawTextIsRead) {
            die("renderForWorkspace: rawText needs to be readRawText()'d first");
        }
        preg_match_all("/\[\[(\d+)\]\]/",
                       $this->rawText, $matches,  PREG_PATTERN_ORDER);
//    echo "<PRE>";print_r($matches);echo "</pre>";
        $docref_ids = $matches[1];
        
        if (count($docref_ids) != 0) {
            // comma sep'd () list
            $docref_ids_sql = "(" . join(",", $docref_ids) . ")";
            //  $msg_ids_js  = "[" . join(",", $msg_ids) . "]"; 
//            echo $docref_ids_sql . "<BR>"; 
        
            $q = "SELECT msg_id, subj, author, docref_id, num_replies
                  FROM msgs, docrefs
                  WHERE docref_id IN $docref_ids_sql AND
                        docrefs.msgowner_id = msgs.msg_id
            ";
            $msg_and_docrefs = $db->getAll($q);
//            echo "<PRE>"; print_r($msg_and_docrefs); echo "</pre>";
            $docref_id_to_msg = Array();
            foreach($msg_and_docrefs as $i => $msg_and_docref) {
                $docref_id_to_msg[(int)$msg_and_docref['docref_id']] =
                    $msg_and_docref;
            }
        }
        
        //------ do the parsing ----
        //------ note that the (d)HTML rendered is heavily interdependent
        //       with marea/workspace.php and marea/ws-doc.inc.php

        $htmlOutput = "";
        $toks = preg_split('/ /', $this->rawText);
        foreach($toks as $i => $tok) {
            if (preg_match("/\[\[(\d+)\]\]/",
                           $tok,
                           $matches)) {
                $docref_id = $matches[1];
                
                $msg = $docref_id_to_msg[$docref_id];
                if ($msg['num_replies'] > 0) {
                    $text  = "[$msg[subj] -$msg[author]";
                    $text .= "<span style=\"font-size:80%\">";
                    $text .= " ($msg[num_replies] replies</span>)]";
                } else {
                    $text  = "[$msg[subj] -$msg[author]]";
                }
                $docref_html =
                    make_docref_html($docref_id, $msg['msg_id'],$text);
                $new_tok = preg_replace(
                    "/\[\[.*\]\]/",
                    $docref_html,
                    $tok);
                $toks[$i] = $new_tok;
            }
            $htmlOutput .= nl2br($toks[$i])
               ."<span class=empty_spot_unhilited onClick=\"selectspot($i);\">".DOC_SPACE."</span>";
        }
        //  echo "<HR><pre>"; print_r($toks); echo "</pre>";
        return $htmlOutput;
    }

    function renderPrefaceForWorkspace() {
        return nl2br($this->preface_text);
    }
    
//     function renderAsPlainText() {
//         if(!$this->rawTextIsRread) {die("need to readRawText() first");}
//         $plaintext = preg_replace_all('/\[\[.*\]\] ', $this->rawText,
//                                       '');
//         return $plaintext;
//     }
}


function array_insert(&$array, $value, $pos)
/* Enters $value at the splice-position $pos. */
{
    if(!is_array($array)) {return False;}
    $last = array_splice($array, $pos);
    array_push($array, $value);
    $array = array_merge($array, $last);
}


function make_docref_html($docref_id, $msg_id, $text)
{
    $r = 
        " <a class=\"docref_unhilited\""
        ." href=curmsg.php?msg_id=$msg_id  target=curmsg"
        ." id=\"docref_id_".$docref_id."\""
        ." onClick=\"docref_click($docref_id, $msg_id);\">"
        ."$text</a> ";
    return $r;
}
?>