<?php


/* two-pass Sorting algorithm inspired from phorum 5
 * to sort message-type trees into outline form
 *
 * Precondition: no child appears before its parent.
 * Easy way to ensure this is for msgs, is to hand it allmsgs in
 * date-sorted order.
 *
 * @param $allnodes is not touched
 * @returns a new list
 */
function treesort($allnodes, $depthkey, $idkey, $parentkey)
{
    $sorted = Array(); //Will be filled with msgs in order
    
    //First do only root messages
    foreach($allnodes as $idx => $node) {
        if ($node[$depthkey] == 0) {
            array_push($sorted, $node);
            unset($allnodes[$idx]);
        }
    }

    //Root msgs have all been processed & moved; now do all children.
    foreach ($allnodes as $node) {
        $i=0;
        while($sorted[$i][$idkey] != $node[$parentkey]) {
            $i++;
            if ($i >= count($sorted)) { die ("went on too long<BR>"); }
        }
        $i++; //Now we'll advance to the end of the children
        while($i < count($sorted) &&
              $sorted[$i][$depthkey] > $node[$depthkey] - 1) {
            $i++;
        }
        array_insert($sorted, $node, $i); // XXX linked list impl? no..?
    }
    return $sorted;
}

function array_insert(&$array, $value, $pos)
/* Enters $value at the splice-pos $pos - i.e. right before the elt at $pos. */
{
    if(!is_array($array)) {return False;}
    $last = array_splice($array, $pos);
    array_push($array, $value);
    $array = array_merge($array, $last);
}

?>