<?php

/* This page appears in one of two ways:
 * (1) loaded in the 100%-sized frame of the popped-open post-popup.php.
 * and does all the actual work of posting.
 *
 * (2) loaded in the curmsg frame of the 4-pane mtg area view.
 *
 * Either way, the parent "caller" should initially pass all important variables
 * via GET.
 */

require_once "../conf.php";
require_once LIB."/Document.php";
require_once LIB."/PodAuth.php";





// XXX - is REQUEST more dangerous than GET || POST ?
//  is it a problem if attacker overloads with cookies?  no,
//  they could do that before via fake GET/POST requests....

//-- Transmitting... we need to pass on certain key/value pairs that
// are received here, in case if the form needs to be reentered.
// these will be HIDDEN variables.  $defaults is for VISIBLE, user-editable
// variables!


$varnames_to_transmit = array(
    'in_reply_to', 'discoowner_id', 'docref_loc', 'doc_id', 'inpopup');

$defaults = array(
    'subj'    => "",
    'msgtext' => "message text");


$vars_to_transmit = array();
foreach( $varnames_to_transmit as $k => $var) {
    if(!isset($_REQUEST[$var])) {
        //die("No  to-be-transmitted '$var' in REQUEST!<BR>");
    } else {
        $vars_to_transmit[$var] = $_REQUEST[$var];
    }
}

function make_hidden_transmitter($assoc_array)
// The output of this goes into a <FORM> field.
{
    $s = "";
    foreach($assoc_array as $k => $v) {
        $s .= ' <input type=hidden ';
        $s .=        ' name ="' .$k. '"';
        $s .=        ' value="' .$v. '">';
    }
    return $s;
}

function make_form($defaults, $vars_to_transmit)
{
    global $auth;
    $s = '
    <form method=POST>
    
    <P>Author: ' . $auth->getUsername() .'

    <P>Subject:
    <input type=text    name="subj" id="subj_input"
        value="' .$defaults['subj']. '">

    <P><BR>
    <textarea           name="msgtext"
        rows=20 cols=65
        style="width:100%;  "
        wrap="virtual"
    >' .$defaults['msgtext']. '</textarea>

' . make_hidden_transmitter($vars_to_transmit) . '

    <input  type=submit 
            name="submit"  value="Post This Message">
    </form>

';

    return $s;
}



function create_new_docref($db, $docref_loc, $docowner_id)
{

//    $db->query("LOCK TABLES docrefs WRITE");     // should be locked beforehand.  keep commented out!!!


    //Doesn't update msgowner_id !!!!  call finish_up_docref() for that
    $q = "INSERT docrefs VALUES
            (null, 0, $docowner_id)";
    $db->query($q);
    $new_docref_id = $db->getOne("SELECT LAST_INSERT_ID()");


    echo "docref_loc: $docref_loc <BR>";

    $doc = new Document;
    $doc->fillFromDB($db, $docowner_id);
    $doc->readRawText();
    $doc->insertNewDocref($docref_loc, $new_docref_id);
    $doc->storeText();

    return $new_docref_id;

}

function finish_up_new_docref($db, $docref_id, $using_msgowner_id)
{
    $db->query("UPDATE docrefs SET msgowner_id = $using_msgowner_id
                WHERE docref_id = $docref_id");
}

function error_callback_whenlocked($error)
{
    global $db;
    
    echo "---- db error!<BR><BR>\n";
    echo nl2br($error->getMessage()) . "<BR>\n";
    echo nl2br($error->getDebugInfo()) . "<BR>\n";
    echo "<BR>---- end db error message.<BR>\n";
    $db->query("UNLOCK TABLES");
    echo "Unlocked the table, now exiting<BR>";
    die();
}

function enter_msg_into_db($db)
// Call this only once you're sure _REQUEST has the right stuff in it
{
    global $auth;
    
    
    $db->query("LOCK TABLES msgs WRITE,
                            docrefs WRITE,
                            docs WRITE");
    $db->setErrorHandling(PEAR_ERROR_CALLBACK, "error_callback_whenlocked");
    
    if( $_REQUEST['in_reply_to'] ) {
        $find_replied_to_q =
            "SELECT msg_id, thread_depth, primary_docref_id
                      FROM msgs
                      WHERE msg_id = ".$_REQUEST['in_reply_to'];

        $replied_to_msg = $db->getRow($find_replied_to_q);
        
        $thread_depth = $replied_to_msg['thread_depth'] + 1;
        $primary_docref_id = $replied_to_msg['primary_docref_id'];

    } else {
         $thread_depth = 0;
         if (isset($_REQUEST['docref_loc'])) {
             $primary_docref_id = create_new_docref(
                 $db, $_REQUEST['docref_loc'], $_REQUEST['doc_id']);
         //Remember, create_new_docref still needs finish_up_new_docref later
         } else {
             $primary_docref_id = 0;
         }
    }

    if ($_REQUEST['subj'] == "") {
        $_REQUEST['subj'] = "no subject";
    }

    //---- finally, the insertion query ----

    $insert_query  = "INSERT msgs VALUES ( "

     . "null, "  //msg_id autoincrements
     . "'" . $_REQUEST['subj']     . "' , "
     . "'" . $_REQUEST['msgtext']  . "' , "
     . $_REQUEST['discoowner_id']  . " , "
     . $_REQUEST['in_reply_to']    . " , "
     . "NOW()  , "
     . $thread_depth . " , "
     . "'" . $auth->getUsername()   . "' , "
     . $primary_docref_id . " , "
     . "0" .   " )"   ;

    echo nl2br($insert_query) . "\n<BR>";

    $db->query($insert_query);

    $inserted_msg_id = $db->getOne("SELECT LAST_INSERT_ID()");

    //----- other stuff

    if(!$_REQUEST['in_reply_to'] && isset($_REQUEST['docref_loc'])) {
        finish_up_new_docref($db, $primary_docref_id, $inserted_msg_id);
    } else {
    }

    // --- num_replies updating: query up the tree
    //     XXX could have 1 less query by writing out the loop-and-a-half
    //         to hard-set in_reply_to from $_REQUEST instead of querying for
    //         it.....
    $in_reply_to = $_REQUEST['in_reply_to'];
    while($in_reply_to != 0) {
        $q = "UPDATE msgs SET num_replies = num_replies+1
              WHERE msg_id = $in_reply_to";
        echo $q . "<BR>";
        $db->query($q);
      
        $q = "SELECT in_reply_to FROM msgs WHERE msg_id = $in_reply_to";
        echo $q . '<BR>';
        $in_reply_to = $db->getOne($q);
    }
        

    $db->query("UNLOCK TABLES");
    $db->setErrorHandling(PEAR_ERROR_CALLBACK, "dbinit_error_callback");
        
    return $inserted_msg_id;

} //end update_db function


function footer_and_exit()
{
    print "<PRE> Request:\n";
    print_r($_REQUEST);
    print "</pre>";

    echo "</body></html>";
    exit;
}

?>
<?

if(!isset($_REQUEST['discoowner_id'])) {
    die("Error, no discoowner_id passed");
}
$auth = new PodAuth();
$auth->start();
if (!$auth->getMembership($_REQUEST['discoowner_id'])) {
    die("You can't post to this discussion.  But you should've received this message earlier, before you had the chance to post, so this probably is a bug,");
}
?>


<HTML>
<HEAD>
<style>
TEXTAREA {
 font-family: Verdana, Arial, sans-serif;
}
</style>
</HEAD>


<BODY
onLoad="var e=document.getElementById('subj_input'); if(e){e.focus();}"
>

<div id=warning_area></div>
<?php



if (isset($_POST['submit'])) {

    require_once LIB ."/dbinit.php";
    $db = dbinit_connect();

    //--- case: bad post, they have to compose again
    //TODO: more bad-posting conditions, ws-discarding regexes?
    //XXX this should be handled by JS to save a form submit or two
    if (//$_POST['msgtext'] == $defaults['msgtext'] ||
        $_POST['msgtext'] == "") {

        echo '<P><span style="color: red;">';
        Echo 'Please Enter A Message in the ';
        echo 'compositon box.</span>';

        //--- fill back in the values they've already written.
        foreach($defaults as $key => $value) {
            if (isset($_REQUEST[$key])) {
                $defaults[$key] = $_POST[$key];
            }
        }
    } else {
        //--- case: do stuff ---

        $new_msg_id = enter_msg_into_db($db); //does lotsa stuff
        echo "<B>new msg id  = $new_msg_id</b><BR>";

        //reload the msglist & possibly workspace
        echo '<P>Your posting is complete! ';

        if($_REQUEST['inpopup']) {
            echo '<script>';
//            if(isset($_REQUEST['docref_loc'])) {
            echo "top.update_workspace();";
//            }
            echo "top.update_msglist($new_msg_id);";
            echo "top.close();";
            echo "</script>";
        } else {
            echo "<script>";
            echo "parent.frames.msglist.reload_and_hilite($new_msg_id);";
            echo "window.location.replace(\"$msgurl\");";
            echo "</script>";
        }

        $marea_name = $db->getOne("SELECT name FROM mareas WHERE marea_id = $_REQUEST[discoowner_id]");

        echo "</body></html>";

        require LIB."/Emailer.php";
        $e = new Emailer;
        $e->setRecipientsWhoWantMail($db);
        $e->setSubject("New message \"$_REQUEST[subj]\" by "
                       .$auth->getUsername());
        $msg =
$auth->getUsername() ." has posted to the meeting area \"$marea_name\".
View at:
  ".POD_URL_ROOT."/marea/?marea_id=$_REQUEST[discoowner_id]&msg_id=$new_msg_id";
        $e->setTextMessage($msg);
        $e->send();
        exit;
    }
}

echo make_form($defaults, $vars_to_transmit);
footer_and_exit();

?>
