-- MySQL dump 8.22
--
-- Host: localhost    Database: pod2
---------------------------------------------------------
-- Server version	3.23.56

--
-- Table structure for table 'docrefs'
--

CREATE TABLE docrefs (
  docref_id int(10) unsigned NOT NULL auto_increment,
  msgowner_id int(10) unsigned NOT NULL default '0',
  docowner_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (docref_id),
  KEY msgowner_id (msgowner_id),
  KEY docowner_id (docowner_id)
) TYPE=MyISAM;

--
-- Dumping data for table 'docrefs'
--


INSERT INTO docrefs VALUES (2,3,2);
INSERT INTO docrefs VALUES (96,155,61);
INSERT INTO docrefs VALUES (95,154,60);
INSERT INTO docrefs VALUES (94,151,60);
INSERT INTO docrefs VALUES (46,66,28);
INSERT INTO docrefs VALUES (93,150,60);

--
-- Table structure for table 'docs'
--

CREATE TABLE docs (
  doc_id int(10) unsigned NOT NULL auto_increment,
  mareaowner_id int(10) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  parent_doc_id int(10) unsigned NOT NULL default '0',
  preface_text longtext NOT NULL,
  preface_last_update datetime NOT NULL default '0000-00-00 00:00:00',
  preface_last_update_by_username varchar(50) NOT NULL default 'userperson',
  orig_author varchar(50) NOT NULL default '',
  when_orig_created datetime NOT NULL default '0000-00-00 00:00:00',
  orig_preface_docref_id int(10) unsigned NOT NULL default '0',
  orig_preface_msg_id int(10) unsigned NOT NULL default '0',
  tag varchar(20) NOT NULL default '',
  PRIMARY KEY  (doc_id)
) TYPE=MyISAM;

--
-- Dumping data for table 'docs'
--


INSERT INTO docs VALUES (2,3,'Glossary',0,'This is a list of the terminology we\'ll use to describe parts of the system.\r\n\r\nCopied over just now; Todd first wrote it.','2003-07-28 21:23:40','brendan','brendan','2003-07-28 21:23:40',2,3,'1.');
INSERT INTO docs VALUES (60,1,'new document',0,'Here\'s the new document, everyone','2003-08-04 18:47:11','brendan','brendan','2003-08-04 18:47:11',93,150,'1.');
INSERT INTO docs VALUES (61,10,'its crazy times!!!!1',0,'Here\'s the new document, everyone','2003-08-04 19:11:07','brendan','brendan','2003-08-04 19:11:07',96,155,'1.');

--
-- Table structure for table 'mareas'
--

CREATE TABLE mareas (
  marea_id int(10) unsigned NOT NULL auto_increment,
  name char(100) NOT NULL default '',
  orgowner_id int(10) unsigned NOT NULL default '0',
  perms_type enum('everyone','admittance') NOT NULL default 'everyone',
  PRIMARY KEY  (marea_id)
) TYPE=MyISAM;

--
-- Dumping data for table 'mareas'
--


INSERT INTO mareas VALUES (1,'The Commons Ain\'t No Tragedy',1,'everyone');
INSERT INTO mareas VALUES (2,'The Budget group',1,'everyone');
INSERT INTO mareas VALUES (3,'meta talk',1,'everyone');
INSERT INTO mareas VALUES (10,'crazy times',1,'everyone');
INSERT INTO mareas VALUES (11,'another area',1,'admittance');
INSERT INTO mareas VALUES (12,'another areasadf',1,'admittance');
INSERT INTO mareas VALUES (13,'qwewq',1,'everyone');
INSERT INTO mareas VALUES (14,'qwewq121',1,'everyone');
INSERT INTO mareas VALUES (15,'sdfgsf',1,'everyone');
INSERT INTO mareas VALUES (16,'werwerwe',1,'everyone');

--
-- Table structure for table 'msgs'
--

CREATE TABLE msgs (
  msg_id int(10) unsigned NOT NULL auto_increment,
  subj varchar(200) default NULL,
  msgtext longtext,
  discoowner_id int(10) unsigned NOT NULL default '0',
  in_reply_to int(10) unsigned NOT NULL default '0',
  when_posted datetime default NULL,
  thread_depth int(10) unsigned NOT NULL default '0',
  author varchar(20) default NULL,
  primary_docref_id int(10) unsigned default NULL,
  num_replies int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (msg_id),
  KEY discoowner_id (discoowner_id)
) TYPE=MyISAM;

--
-- Dumping data for table 'msgs'
--


INSERT INTO msgs VALUES (3,'New Document: \"Glossary\"','This is a list of the terminology we\'ll use to describe parts of the system.\r\n\r\nCopied over just now; Todd first wrote it.',3,0,'2003-07-28 21:23:40',0,'brendan',2,0);
INSERT INTO msgs VALUES (155,'New Document: \"its crazy times!!!!1\"','Here\'s the new document, everyone',10,0,'2003-08-04 19:11:07',0,'brendan',96,0);
INSERT INTO msgs VALUES (154,'comment near end','message text',1,0,'2003-08-04 18:48:23',0,'brendan',95,0);
INSERT INTO msgs VALUES (153,'reply','message text',1,151,'2003-08-04 18:48:12',1,'brendan',94,0);
INSERT INTO msgs VALUES (152,'da da dum','message text',1,150,'2003-08-04 18:47:47',1,'brendan',93,0);
INSERT INTO msgs VALUES (151,'here','message text',1,0,'2003-08-04 18:47:22',0,'brendan',94,1);
INSERT INTO msgs VALUES (150,'New Document: \"new document\"','Here\'s the new document, everyone',1,0,'2003-08-04 18:47:11',0,'brendan',93,1);

--
-- Table structure for table 'orgs'
--

CREATE TABLE orgs (
  org_id int(10) unsigned NOT NULL auto_increment,
  name char(100) NOT NULL default '',
  PRIMARY KEY  (org_id)
) TYPE=MyISAM;

--
-- Dumping data for table 'orgs'
--


INSERT INTO orgs VALUES (1,'The Organization');

--
-- Table structure for table 'usermareas'
--

CREATE TABLE usermareas (
  username varchar(15) NOT NULL default '',
  marea_id int(10) unsigned NOT NULL default '0',
  KEY username (username),
  KEY marea_id (marea_id)
) TYPE=MyISAM;

--
-- Dumping data for table 'usermareas'
--


INSERT INTO usermareas VALUES ('Todd',3);
INSERT INTO usermareas VALUES ('brendan',3);
INSERT INTO usermareas VALUES ('mic',3);

--
-- Table structure for table 'users'
--

CREATE TABLE users (
  user_id int(10) unsigned NOT NULL auto_increment,
  username varchar(15) NOT NULL default '',
  password varchar(30) NOT NULL default '',
  password_md5 varchar(32) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  firstname varchar(100) default NULL,
  lastname varchar(100) default NULL,
  wants_email tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (user_id),
  UNIQUE KEY nickname (username)
) TYPE=MyISAM;

--
-- Dumping data for table 'users'
--


INSERT INTO users VALUES (10,'guest','guest','084e0343a0486ff05530df6c705c8bb4','nobody@nowhere.org','','',0);
INSERT INTO users VALUES (9,'brendan','asdf','912ec803b2ce49e4a541068d495ab570','brendano@stanford.edu','Brendan','O\'Connor',1);
INSERT INTO users VALUES (19,'mic','','d41d8cd98f00b204e9800998ecf8427e','mic@linefeed.org','','',0);
INSERT INTO users VALUES (18,'Todd','Mr.gumpys','ee6d11f43f99deac3cfa36bbe09780da','tdavies@csli.stanford.edu','Todd','Davies',0);
INSERT INTO users VALUES (20,'rolando','pieces','6b7e900d1449ef960e49d909ed27f249','rolando@pluggedin.org','Rolando','Zeledon',0);

